import { Descriptor } from './descriptors';
import { IInstantiationService, ServicesAccessor } from './instantiation';
import { ServiceCollection } from './serviceCollection';
export declare class InstantiationService implements IInstantiationService {
    _serviceBrand: undefined;
    private readonly _services;
    private readonly _strict;
    private readonly _parent?;
    constructor(services?: ServiceCollection, strict?: boolean, parent?: InstantiationService);
    createChild(services: ServiceCollection): IInstantiationService;
    invokeFunction<R, TS extends any[] = []>(fn: (accessor: ServicesAccessor, ...args: TS) => R, ...args: TS): R;
    createInstance(ctorOrDescriptor: any | Descriptor<any>, ...rest: any[]): any;
    private _createInstance;
    private _setServiceInstance;
    private _getServiceInstanceOrDescriptor;
    private _getOrCreateServiceInstance;
    private _createAndCacheServiceInstance;
    private _createServiceInstanceWithOwner;
    private _createServiceInstance;
}
